<template>
  <div>
    <b-breadcrumb class="py-1 pl-2" :items="breadcrumbs"></b-breadcrumb>
    <b-card class="h-100">
      <!-- <pre>{{ getDatosMovimientos }}</pre> -->
      <pre>{{ getDatosFuncionarios }}</pre>
      <b-card-title>
        <b-row align-h="between">
          <b-col cols="auto"> Movimiento </b-col>
          <b-col cols="auto">
            <b-button
              @click="abrirForm"
              variant="success"
              size="sm"
              class="mr-1"
            >
              <b-icon icon="plus"></b-icon>
              Crear
            </b-button>
          </b-col>
        </b-row>
      </b-card-title>
      <!-- User Interface controls -->
      <Table
        :keyTable="keyTable"
        :filter="filter"
        :items="items"
        :title="'Movimientos'"
        :fields="fields"
        :totalRows="getDatosMovimientos.total"
        @mostarItem="mostarItem"
        @editarItem="editarItem"
        @eliminarItem="eliminarItem"
        @searchOrShortOrPage="listar"
      ></Table>

      <b-modal hide-footer :id="infoModal.id" :title="infoModal.title" ok-only>
        <Form
          v-if="infoModal.title"
          title="Partner Editor"
          :schema="schema"
          :model="item"
          @guardarForm="guardarForm"
          @actualizarForm="actualizarForm"
          @cerrarForm="cerrarForm"
        >
        </Form>
      </b-modal>
    </b-card>
  </div>
</template>

<script>
import Table from "../../components/table.vue";
import Form from "../../components/Form.vue";
import Swal from "sweetalert2";
import moment from "moment";
import { mapGetters } from "vuex";
import _ from "lodash";
import {
  LISTAR_MOVIMIENTOS,
  GUARDAR_MOVIMIENTOS,
  MOSTRAR_MOVIMIENTOS,
  ACTUALIZAR_MOVIMIENTOS,
} from "../../store/modules/movimiento.module";
import { LISTAR_TIPO_MOVIMIENTOS } from "../../store/modules/tipomovimiento.module";
import { LISTAR_FUNCIONARIOS } from "../../store/modules/funcionario.module";
import { LISTAR_DETALLE_CAJAS } from "../../store/modules/detallecaja.module";

export default {
  components: {
    Table,
    Form,
  },
  data() {
    return {
      filter: { search: "", perPage: 10, sortBy: "id", currentPage: 1 },
      keyTable: Number(moment.unix),
      breadcrumbs: [
        {
          text: "Inicio",
          to: { name: "Inicio" },
          active: false,
        },
        {
          text: "Movimientos",
          href: "#",
          active: true,
        },
      ],
      fields: [
        {
          key: "id",
          label: "#",
          sortable: true,
          // sortDirection: "asc",
          class: "text-center",
        },
        {
          key: "descripcion",
          label: "Descripcion",
          sortable: true,
          class: "text-center",
        },
        {
          key: "fecha",
          label: "Fecha",
          sortable: true,
          class: "text-center",
        },
        {
          key: "tipo_movimiento",
          label: "Tipo movimiento",
          formatter: (value) => {
            console.log(value);
            return value ? value.nombre : "";
          },
          sortable: true,
          class: "text-center",
        },
        {
          key: "created_at",
          label: "Creado",
          sortable: true,
          formatter: (value) => {
            return value ? moment(value).format("DD-MM-YYYY H:mm:ss") : "";
          },
          class: "text-center",
        },
        {
          key: "updated_at",
          label: "Actualizado",
          sortable: true,
          formatter: (value) => {
            return value ? moment(value).format("DD-MM-YYYY H:mm:ss") : "";
          },
          class: "text-center",
        },
        // {
        //   key: "isActive",
        //   label: "Is Active",
        //   formatter: (value) => {
        //     return value ? "Yes" : "No";
        //   },
        //   sortable: true,
        //   sortByFormatted: true,
        //   filterByFormatted: true,
        // },

        { key: "acciones", label: "acciones", class: "text-center" },
      ],
      schema: {
        fields: [
          {
            type: "text",
            name: "descripcion",
            label: "Descripcion",
            placeholder: "Ingrese el descripcion",
            _validate: {
              required: true,
            },
          },
          {
            type: "text",
            name: "fecha",
            label: "Fecha",
            placeholder: "Ingrese el fecha",
            _validate: {
              required: true,
            },
          },
          {
            type: "select",
            name: "tipo_movimiento",
            label: "Tipo movimiento",
            placeholder: "Ingrese la Tipo movimiento",
            _validate: {
              required: true,
            },
            list: [],
          },
          {
            type: "select",
            name: "proyecto",
            label: "Proyectos",
            placeholder: "Ingrese la detalle caja",
            _validate: {
              required: true,
            },
            list: [],
          },
          {
            type: "select",
            name: "detalle_caja",
            label: "Caja",
            placeholder: "Ingrese la detalle caja",
            _validate: {
              required: true,
            },
            list: [],
          },
          {
            type: "select",
            name: "detalle_caja",
            label: "Detalle caja",
            placeholder: "Ingrese la detalle caja",
            _validate: {
              required: true,
            },
            list: [],
          },
          {
            type: "select",
            name: "detalle_caja",
            label: "Detalle caja",
            placeholder: "Ingrese la detalle caja",
            _validate: {
              required: true,
            },
            list: [],
          },
          {
            type: "select",
            name: "funcionario",
            label: "Funcionario",
            placeholder: "Ingrese el Funcionario",

            _validate: {
              required: true,
            },
            list: [],
          },
        ],
      },
      item: {
        id: null,
        descripcion: "",
        fecha: "",
        tipo_movimiento: "",
      },
      infoModal: {
        id: "info-modal",
        title: "",
        content: "",
      },
    };
  },
  computed: {
    ...mapGetters([
      "getDatosMovimientos",
      "getMovimiento",
      "getDatosTipoMovimientos",
      "getDatosFuncionarios",
      "getDatosDetalleCajas",
    ]),
    items() {
      return _.map(this.getDatosMovimientos.data, (movimiento) => {
        return (movimiento = {
          ...movimiento,
          acciones: {
            mostrar: {
              name: "mostrar",
              label: "Mostrar",
              show: false,
              color: "primary",
            },
            editar: {
              name: "editar",
              label: "Editar",
              show: true,
              color: "warning",
            },
            eliminar: {
              name: "eliminar",
              label: "Eliminar",
              show: false,
              color: "danger",
            },
          },
        });
        // .acciones=[
        //   {
        //     name:"Mostar",
        //   }
        // ]
      });
    },
  },
  mounted() {
    // Set the initial number of items
    this.totalRows = this.items.length;
    this.listar();
  },
  methods: {
    listar() {
      let data = {
        search: this.filter.search ?? "",
        per_page: this.filter.perPage ?? 10,
        sort_by: this.filter.sortBy ?? "id",
        page: this.filter.currentPage ?? 1,
      };
      console.log("ddddddddddddddddddddddddd", data);
      this.$store.dispatch(LISTAR_MOVIMIENTOS, data).then(() => {
        this.keyTable++;
      });
    },
    listarFuncionario() {
      let data = {
        search: "",
        per_page: 10,
        sort_by: "id",
        page: 1,
      };
      this.$store.dispatch(LISTAR_FUNCIONARIOS, data).then(() => {
        this.schema.fields[4].list = _.map(
          this.getDatosFuncionarios.data,
          (funcionario) => {
            return { text: funcionario.nombre, value: funcionario.id };
          }
        );
      });
    },
    listarTipoMovimiento() {
      let data = {
        search: "",
        per_page: 10,
        sort_by: "id",
        page: 1,
      };
      this.$store.dispatch(LISTAR_TIPO_MOVIMIENTOS, data).then(() => {});
    },
    listarDetalleCaja() {
      let data = {
        search: "",
        per_page: 10,
        sort_by: "id",
        page: 1,
      };
      this.$store.dispatch(LISTAR_DETALLE_CAJAS, data).then(() => {});
    },
    vaciarItem() {
      this.item = {
        id: null,
        descripcion: "",
        fecha: "",
        tipo_movimiento: "",
      };
    },
    abrirForm: function () {
      this.infoModal.title = "Nuevo movimiento";
      this.vaciarItem();
      this.$root.$emit("bv::show::modal", this.infoModal.id);
      this.listarFuncionario();
    },
    guardarForm: async function (data) {
      console.log(data);
      try {
        this.$store
          .dispatch(GUARDAR_MOVIMIENTOS, data)
          .then(() => this.cerrarForm())
          .catch((e) => {
            console.log("eeeeeeeeeeeeeeeee", e);
          });
      } catch (e) {
        console.log("eeeeeeeeeeeeeeeee", e);
        Swal.fire("Error!", e, "error");
      }
    },
    actualizarForm: async function (data) {
      console.log(data);
      try {
        this.$store
          .dispatch(ACTUALIZAR_MOVIMIENTOS, data)
          .then(() => this.cerrarForm())
          .catch((e) => {
            console.log("eeeeeeeeeeeeeeeee", e);
          });
      } catch (e) {
        console.log("eeeeeeeeeeeeeeeee2", e);

        Swal.fire("Error!", e, "error");
      }
    },
    cerrarForm: function () {
      this.infoModal.title = "";
      this.item = {
        id: null,
        descripcion: "",
        fecha: "",
        tipo_movimiento: "",
      };
      this.$root.$emit("bv::hide::modal", this.infoModal.id);
    },
    mostarItem(id) {
      // this.$dispatch(SHOW_MOVIMIENTOS, { id });
      this.infoModal.title = "Mostrar movimiento";
      // this.vaciarItem();
      this.$root.$emit("bv::show::modal", this.infoModal.id);
    },
    editarItem(id) {
      this.$store.dispatch(MOSTRAR_MOVIMIENTOS, { id }).then(() => {
        this.infoModal.title = "Editar movimiento";
        this.item = this.getMovimiento;
        // this.vaciarItem();
        this.listarFuncionario();
        this.$root.$emit("bv::show::modal", this.infoModal.id);
      });
    },
    eliminarItem(id) {
      // this.$dispatch(_MOVIMIENTOS,id)
    },
  },
};
</script>